    View Javadoc
    1   package org.apache.bcel.classfile;
    2
    3   /* ====================================================================
    4    * The Apache Software License, Version 1.1
    5    *
    6    * Copyright (c) 2001 The Apache Software Foundation.  All rights
    7    * reserved.
    8    *
    9    * Redistribution and use in source and binary forms, with or without
    10   * modification, are permitted provided that the following conditions
    11   * are met:
    12   *
    13   * 1. Redistributions of source code must retain the above copyright
    14   *    notice, this list of conditions and the following disclaimer.
    15   *
    16   * 2. Redistributions in binary form must reproduce the above copyright
    17   *    notice, this list of conditions and the following disclaimer in
    18   *    the documentation and/or other materials provided with the
    19   *    distribution.
    20   *
    21   * 3. The end-user documentation included with the redistribution,
    22   *    if any, must include the following acknowledgment:
    23   *       "This product includes software developed by the
    24   *        Apache Software Foundation (http://www.apache.org/)."
    25   *    Alternately, this acknowledgment may appear in the software itself,
    26   *    if and wherever such third-party acknowledgments normally appear.
    27   *
    28   * 4. The names "Apache" and "Apache Software Foundation" and
    29   *    "Apache BCEL" must not be used to endorse or promote products
    30   *    derived from this software without prior written permission. For
    31   *    written permission, please contact apache@apache.org.
    32   *
    33   * 5. Products derived from this software may not be called "Apache",
    34   *    "Apache BCEL", nor may "Apache" appear in their name, without
    35   *    prior written permission of the Apache Software Foundation.
    36   *
    37   * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
    38   * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
    39   * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
    40   * DISCLAIMED.  IN NO EVENT SHALL THE APACHE SOFTWARE FOUNDATION OR
    41   * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
    42   * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
    43   * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
    44   * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
    45   * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
    46   * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
    47   * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    48   * SUCH DAMAGE.
    49   * ====================================================================
    50   *
    51   * This software consists of voluntary contributions made by many
    52   * individuals on behalf of the Apache Software Foundation.  For more
    53   * information on the Apache Software Foundation, please see
    54   * <http://www.apache.org/>;.
    55   */
    56
    57  import  org.apache.bcel.Constants;
    58  import  java.io.*;
    59
    60  /***
    61   * This class is derived from <em>Attribute</em> and represents a reference
    62   * to a <a href="http://www.inf.fu-berlin.de/~bokowski/pmgjava/index.html">PMG</a>
    63   * attribute.
    64   *
    65   * @version $Id: PMGClass.java,v 1.2 2002/03/11 16:16:35 mdahm Exp $
    66   * @author  <A HREF="mailto:markus.dahm@berlin.de">M. Dahm</A>
    67   * @see     Attribute
    68   */
    69  public final class PMGClass extends Attribute {
    70    private int pmg_class_index, pmg_index;
    71
    72    /***
    73     * Initialize from another object. Note that both objects use the same
    74     * references (shallow copy). Use clone() for a physical copy.
    75     */
    76    public PMGClass(PMGClass c) {
    77      this(c.getNameIndex(), c.getLength(), c.getPMGIndex(), c.getPMGClassIndex(),
    78  	 c.getConstantPool());
    79    }
    80
    81    /***
    82     * Construct object from file stream.
    83     * @param name_index Index in constant pool to CONSTANT_Utf8
    84     * @param length Content length in bytes
    85     * @param file Input stream
    86     * @param constant_pool Array of constants
    87     * @throws IOException
    88     */
    89    PMGClass(int name_index, int length, DataInputStream file,
    90  	   ConstantPool constant_pool) throws IOException
    91    {
    92      this(name_index, length, file.readUnsignedShort(), file.readUnsignedShort(),
    93  	 constant_pool);
    94    }
    95
    96    /***
    97     * @param name_index Index in constant pool to CONSTANT_Utf8
    98     * @param length Content length in bytes
    99     * @param constant_pool Array of constants
    100    * @param PMGClass_index Index in constant pool to CONSTANT_Utf8
    101    */
    102   public PMGClass(int name_index, int length, int pmg_index, int pmg_class_index,
    103 		  ConstantPool constant_pool)
    104   {
    105     super(Constants.ATTR_PMG, name_index, length, constant_pool);
    106     this.pmg_index       = pmg_index;
    107     this.pmg_class_index = pmg_class_index;
    108   }
    109
    110   /***
    111    * Called by objects that are traversing the nodes of the tree implicitely
    112    * defined by the contents of a Java class. I.e., the hierarchy of methods,
    113    * fields, attributes, etc. spawns a tree of objects.
    114    *
    115    * @param v Visitor object
    116    */
    117    public void accept(Visitor v) {
    118      System.err.println("Visiting non-standard PMGClass object");
    119    }
    120
    121   /***
    122    * Dump source file attribute to file stream in binary format.
    123    *
    124    * @param file Output file stream
    125    * @throws IOException
    126    */
    127   public final void dump(DataOutputStream file) throws IOException
    128   {
    129     super.dump(file);
    130     file.writeShort(pmg_index);
    131     file.writeShort(pmg_class_index);
    132   }
    133
    134   /***
    135    * @return Index in constant pool of source file name.
    136    */
    137   public final int getPMGClassIndex() { return pmg_class_index; }
    138
    139   /***
    140    * @param PMGClass_index.
    141    */
    142   public final void setPMGClassIndex(int pmg_class_index) {
    143     this.pmg_class_index = pmg_class_index;
    144   }
    145
    146   /***
    147    * @return Index in constant pool of source file name.
    148    */
    149   public final int getPMGIndex() { return pmg_index; }
    150
    151   /***
    152    * @param PMGClass_index.
    153    */
    154   public final void setPMGIndex(int pmg_index) {
    155     this.pmg_index = pmg_index;
    156   }
    157
    158   /***
    159    * @return PMG name.
    160    */
    161   public final String getPMGName() {
    162     ConstantUtf8 c = (ConstantUtf8)constant_pool.getConstant(pmg_index,
    163 							     Constants.CONSTANT_Utf8);
    164     return c.getBytes();
    165   }
    166
    167   /***
    168    * @return PMG class name.
    169    */
    170   public final String getPMGClassName() {
    171     ConstantUtf8 c = (ConstantUtf8)constant_pool.getConstant(pmg_class_index,
    172 							     Constants.CONSTANT_Utf8);
    173     return c.getBytes();
    174   }
    175
    176   /***
    177    * @return String representation
    178    */
    179   public final String toString() {
    180     return "PMGClass(" + getPMGName() + ", " + getPMGClassName() + ")";
    181   }
    182
    183   /***
    184    * @return deep copy of this attribute
    185    */
    186   public Attribute copy(ConstantPool constant_pool) {
    187     return (PMGClass)clone();
    188   }
    189 }

This page was automatically generated by Maven